//+------------------------------------------------------------------+
//|                                                 FXScanGenOsc.mq4 |
//|                                     Copyright  2012, FX-Scanner |
//|                                        http://www.fx-scanner.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, FX-Scanner"
#property link      "http://www.fx-scanner.com"

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 1
#property  indicator_color1  White
#property  indicator_width1  1
//---- indicator parameters
string   Name="TDI RED GREEN";

extern double    Param1=13;
extern double    Param2=0;
extern double    Param3=34;
extern double    Param4=2;
extern double    Param5=0;
extern double    Param6=7;
extern double    Param7=0;


//---- indicator buffers

double     SignalBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings

   SetIndexStyle(0,DRAW_LINE);
   
   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,SignalBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName(Name+","+Param1+","+Param2+","+Param3+","+Param4+","+Param5+","+Param6+","+Param7+")");
   SetIndexLabel(0,"Signal");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+

int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
   double RSI,TSL;
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;

   for(int i=0; i<limit; i++){
   
         RSI=iCustom(NULL,0, Name,Param1, Param2, Param3, Param4, Param5, Param6, Param7, 4,i);
         TSL=iCustom(NULL,0, Name,Param1, Param2, Param3, Param4, Param5, Param6, Param7, 5,i);
         
         SignalBuffer[i] = iCustom(NULL,0, Name,Param1, Param2, Param3, Param4, Param5, Param6, Param7, 4,i)-iCustom(NULL,0, Name,Param1, Param2, Param3, Param4, Param5, Param6, Param7, 2,i);
         
         if (MathAbs(TSL-50)-MathAbs(RSI-50)<0) SignalBuffer[i] =0;
         
         if(SignalBuffer[i]>0 && RSI<50 )  SignalBuffer[i] =0;
         if(SignalBuffer[i]<0 && RSI>50 )  SignalBuffer[i] =0;
      }
      
   //---- done
   return(0);
  }
//+------------------------------------------------------------------+